//-----------------------------------------------------------------------------
//    FWK_HIN_PRHD_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------

package sim.test.framework.fwk_hin_prhd;


//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------


import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;


/**
 * Test Area: Handler Integrity
 *
 * Applet is triggered on Install (Install), all events
 *
 * @version 0.1.0 - 24/06/02
 *
 */

 public class FWK_HIN_PRHD_1 extends TestToolkitApplet{

     private byte testCaseNb = (byte) 0x00;

     private byte[] TEXT = {(byte)'T',(byte)'E',(byte)'X',(byte)'T',(byte)' ',(byte)'1'};
     private byte[] menuEntry1 = {(byte)'M',(byte)'e',(byte)'n',(byte)'u',(byte)' ',(byte)'1'};
     private byte[] menuEntry2 = {(byte)'M',(byte)'e',(byte)'n',(byte)'u',(byte)' ',(byte)'2'};
     private byte[] eventList ={(byte)12,(byte)13,(byte)14,(byte)15,(byte)16,(byte)17,(byte)18, EVENT_EVENT_DOWNLOAD_LANGUAGE_SELECTION, EVENT_EVENT_DOWNLOAD_BROWSER_TERMINATION, EVENT_FORMATTED_SMS_CB};
     private boolean bRes;

     private byte a;


    //Constructor of the applet

    public FWK_HIN_PRHD_1(){

        obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_ENV);
        //register to EVENT_CALL_CONTROL_BY_SIM
        obReg.setEvent(EVENT_CALL_CONTROL_BY_SIM);
        //register to EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM
        obReg.setEvent(EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM);
        //register to EVENT_UNFORMATTED_SMS_CB
        obReg.setEvent(EVENT_UNFORMATTED_SMS_CB);
        //register to EVENT_MENU_SELECTION
        obReg.initMenuEntry(menuEntry1,(short)0,(short)menuEntry1.length,(byte)0,false,(byte)0,(short)0);
        //register to EVENT_MENU_SELECTION_HELP_REQUEST
        obReg.initMenuEntry(menuEntry2,(short)0,(short)menuEntry2.length,(byte)0,true,(byte)0,(short)0);
        //register to EVENT_TIMER_EXPIRATION
        for(a=0; a<(byte)8; a++){
       	   	obReg.allocateTimer();
       	}
       	for(a=2; a<(byte)9; a++){
       	   	obReg.releaseTimer((byte)a);
       	}
        //register to all event download
        obReg.setEventList(eventList,(short)0,(short)eventList.length);
        //register to EVENT_STATUS_COMMAND
        obReg.requestPollInterval((short)POLL_SYSTEM_DURATION);
        //register to EVENT_PROFILE_DOWNLOAD
        obReg.setEvent(EVENT_PROFILE_DOWNLOAD);
        //register to EVENT_UNRECOGNIZED_ENVELOPE
        obReg.setEvent(EVENT_UNRECOGNIZED_ENVELOPE);
    }


    //Method called by the JCRE at the installation of the applet
    public static void install (byte bArray[], short bOffset, byte bLength){

        //Create a new applet instace
        FWK_HIN_PRHD_1 thisApplet = new FWK_HIN_PRHD_1();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        // Initialise the data of the test applet
        thisApplet.init();
    }


    //Method called by the SIM Toolkit Framework

    public void processToolkit(byte event){

        switch(event){

            //event EVENT_PROFILE_DOWNLOAD
            case EVENT_PROFILE_DOWNLOAD:
            //event EVENT_FORMATTED_SMS_PP_ENV
            case EVENT_FORMATTED_SMS_PP_ENV:
            //event EVENT_UNFORMATTED_SMS_PP_ENV
            case EVENT_UNFORMATTED_SMS_PP_ENV:
            //event EVENT_UNFORMATTED_SMS_CB
            case EVENT_UNFORMATTED_SMS_CB:
            //event EVENT_MENU_SELECTION
            case EVENT_MENU_SELECTION:
            //event EVENT_MENU_SELECTION_HELP_REQUEST
            case EVENT_MENU_SELECTION_HELP_REQUEST:
            //event EVENT_CALL_CONTROL_BY_SIM
            case EVENT_CALL_CONTROL_BY_SIM:
            //event EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM
            case EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM:
            //event EVENT_TIMER_EXPIRATION
            case EVENT_TIMER_EXPIRATION:
            //event EVENT_EVENT_DOWNLOAD_MT_CALL
            case EVENT_EVENT_DOWNLOAD_MT_CALL:
            //event EVENT_EVENT_DOWNLOAD_CALL_CONNECTED
            case EVENT_EVENT_DOWNLOAD_CALL_CONNECTED:
            //event EVENT_EVENT_DOWNLOAD_CALL_DISCONNECTED
            case EVENT_EVENT_DOWNLOAD_CALL_DISCONNECTED:
            //event EVENT_EVENT_DOWNLOAD_LOCATION_STATUS
            case EVENT_EVENT_DOWNLOAD_LOCATION_STATUS:
            //event EVENT_EVENT_DOWNLOAD_USER_ACTIVITY
            case EVENT_EVENT_DOWNLOAD_USER_ACTIVITY:
            //event EVENT_EVENT_DOWNLOAD_IDLE_SCREEN_AVAILABLE
            case EVENT_EVENT_DOWNLOAD_IDLE_SCREEN_AVAILABLE:
            //event EVENT_EVENT_DOWNLOAD_CARD_READER_STATUS
            case EVENT_EVENT_DOWNLOAD_CARD_READER_STATUS:
            //event EVENT_STATUS_COMMAND
            case EVENT_STATUS_COMMAND:
            //event EVENT_UNRECOGNIZED_ENVELOPE
            case EVENT_UNRECOGNIZED_ENVELOPE:
            //event EVENT_EVENT_DOWNLOAD_LANGUAGE_SELECTION
            case EVENT_EVENT_DOWNLOAD_LANGUAGE_SELECTION:
            //event EVENT_EVENT_DOWNLOAD_BROWSER_TERMINATION
            case EVENT_EVENT_DOWNLOAD_BROWSER_TERMINATION:
            //event EVENT_FORMATTED_SMS_CB
            case EVENT_FORMATTED_SMS_CB:


            try{
                    bRes=true;
                    testCaseNb++;
                    try{
                    	ProactiveResponseHandler prRespHdlr = ProactiveResponseHandler.getTheHandler();
                    	if(prRespHdlr.getLength()!=0){
                    		bRes=false;
                    	}
                    }
                    catch(ToolkitException e){
                    	if(e.getReason()!=ToolkitException.HANDLER_NOT_AVAILABLE){
                    		bRes=false;
                    	}
                    }
                    catch(Exception e){
                    		bRes=false;
                    }
                    if(bRes){
                    	//get the Proactive Handler and the Proactive Response Handler
                    	ProactiveHandler prHdlr = ProactiveHandler.getTheHandler();
                    	//build a Proactive Command Display Text
                    	prHdlr.initDisplayText((byte)0x80,DCS_8_BIT_DATA,TEXT,(short)0,(short)TEXT.length);
                    	//send the command Display Text
                    	if(prHdlr.send()==0){
                        	//The ProactiveResponseHandler contains the terminal response
                        	ProactiveResponseHandler prRespHdlr = ProactiveResponseHandler.getTheHandler();
                        	//the handler length should be 12
                        	if(prRespHdlr.getLength()==(byte)12){
                            		//No exception is thrown and the Proactive Response Handler remains unchanged
                            		prHdlr.init(PRO_CMD_SELECT_ITEM,(byte)0x00,DEV_ID_ME);
                            		prHdlr.appendTLV((byte)(TAG_ITEM_IDENTIFIER|TAG_SET_CR),(byte)0x01);
                            		if(prHdlr.send()==0){
                                		//The ProactiveResponseHandler contains the terminal response of the second proactive command
                                		//the handler length should be 15
                                		if(prRespHdlr.getLength()!=(byte)15){
                                    			bRes=false;
                                		}
                            		}
                             		else{
                                		bRes=false;
                            		}
                        	}
                        	else{
                            		bRes=false;
                        	}
                    	}
                    	else{
                        	bRes=false;
                    	}
                    }


            }
            catch(Exception e){
                bRes=false;
            }
            //create the table of the results
            if(event==EVENT_PROFILE_DOWNLOAD){
            	obReg.clearEvent(event);
            }
            reportTestOutcome(testCaseNb,bRes);
            }
        }
}
